# Copyright (C) 2020  The Software Heritage developers
# See the AUTHORS file at the top-level directory of this distribution
# License: GNU Affero General Public License version 3, or any later version
# See top-level LICENSE file for more information

import django.contrib.auth.models
from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ("auth", "0011_update_proxy_permissions"),
    ]

    operations = [
        migrations.CreateModel(
            name="OIDCUserOfflineTokens",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("user_id", models.CharField(max_length=50)),
                ("creation_date", models.DateTimeField(auto_now_add=True)),
                ("offline_token", models.BinaryField()),
            ],
            options={"db_table": "oidc_user_offline_tokens",},
        ),
        migrations.CreateModel(
            name="OIDCUser",
            fields=[],
            options={"proxy": True, "indexes": [], "constraints": [],},
            bases=("auth.user",),
            managers=[("objects", django.contrib.auth.models.UserManager()),],
        ),
    ]
